{===========================================================================}
{==                                                                       ==}
{==                            4EDIT Version 3.0                          ==}
{==                 Copyright (C) 1996-97 By The GodFather                ==}
{==                                                                       ==}
{===========================================================================}

{$M, 16384,65535,655350}   {16Kb Stack, 640Kb Heap}

USES Dos,
     GUtils, GMemory, GList, GDialogs, GStdDlgs, GErrors;

{ DEFINE Debug}

{$IFDEF Debug}
  {D+,L+,I+,Q-,R+,S+}
{$ELSE}
  {D-,L-,I-,Q-,R-,S-}
{$ENDIF}

{$DEFINE _4DOS_60}

CONST
 {$IFDEF _4DOS_60}
  Version = 'Version 3.1';
 {$ELSE}
  Version = 'Version 3.0';
 {$ENDIF}

TYPE
  DescStr = STRING[240];
  FileStr = STRING[12];
  String40= STRING[40];

  PFile   = ^TFile;
  TFile   = OBJECT(TObject)
    Name  : FileStr;
    Desc  : DescStr;
    Size  : LongInt;
    Attr  : Byte;
    Date  : LongInt;
    Dir   : Boolean;
    FUNCTION GetDesc: DescStr;
    PROCEDURE SetDesc(ADesc:DescStr);
    CONSTRUCTOR Init(AName:FileStr; ASize:LongInt; AAttr:Byte; ADate:LongInt);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PFilesList = ^TFilesList;
  TFilesList = OBJECT(TList)
    FUNCTION  __GetLine(ListPos:Integer): STRING; VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
    PROCEDURE __IdleListCall(ListPos:Integer); VIRTUAL;
  END;



VAR
  Files       : PCollection;
  FilesList   : PFilesList;
  TotalSize   : LongInt;
  FullDesc    : ARRAY[1..6] OF DescStr;
  Clipboard   : DescStr;
  Edited      : Boolean;

  CurrentFile : PFile;

  OrigDir,
  CurrDir,
  OldDir      : STRING;

  Upper_ASCII : Byte;
  Upper_ASCII2: Byte;
  InsertMode  : Boolean;
  NormalLines : Boolean;



{***************************************************************************}
{*************************** LINK OBJECT FILES *****************************}
{***************************************************************************}
PROCEDURE _4E_Logo;    EXTERNAL; {$L 4EDIT31\4E_LOGO.OBJ}
PROCEDURE _4E_Pallete; EXTERNAL; {$L 4EDIT31\4E_PAL.OBJ}



{***************************************************************************}
{************************** SET DEFAULT PALLETE ****************************}
{***************************************************************************}
TYPE
  PPallete = ^TPallete;
  TPallete = ARRAY[1..768] OF Byte;

 PROCEDURE VRetrace; ASSEMBLER;
 ASM
   MOV DX, 03DAh
   @1: IN AL, DX; TEST AL,08h;  JZ @1;
   @2: IN AL, DX; TEST AL,08h; JNZ @2;
 END;

 PROCEDURE Pallete(P:PPallete);
 VAR Index:Word;
 BEGIN
   VRetrace;
   Port[$3C8] := 0; {Set first color}
   FOR Index := 1 TO 768 DO Port[$3C9] := P^[Index];
 END;

 PROCEDURE SetDefaultPal;
 BEGIN
   Pallete(@_4E_Pallete);
 END;



{===========================================================================}
{=== Help & ViewASCII PROCEDURES ===========================================}
{===========================================================================}
PROCEDURE DrawMainScreen;
BEGIN
  Cursor(Off);
  SetBlink(False);
  SetPAL(AltPAL);
  SetDefaultPal;
  FastWrite(1,1,$0A,PadCenter('4EDIT '+Version+' by The GodFather',80,' '));
  FastWrite(1,2,$19,Replicate(80,#205));
  FBox(1,2,80,MaxY,$19,Double1);
  SmartHLine(1,80,MaxY-7,$19,SingleLine);
  SmartVLine(37  ,MaxY-7,MaxY-1,$19,SingleLine);
  FastWrite( 4,2,$1B,' Filename ');
  FastWrite(20,2,$1B,' Size ');
  FastWrite(52,2,$1B,' Description ');
  FastWrite(40,MaxY-7,$1B,' Full Description ');
  FastWrite(3,MaxY-6,$17,'       Name:');
  FastWrite(3,MaxY-5,$17,'       Size:');
  FastWrite(3,MaxY-4,$17,'  Date&Time:');
  FastWrite(3,MaxY-3,$17,' Attributes:');
  FastWrite(3,MaxY-2,$17,'Total files:');
  FastWrite(3,MaxY-1,$17,'Total sizes:');
  PosCursor(80,MaxY);
END;

PROCEDURE Help(HelpNum:Byte);
VAR I,R:Byte; X,X2,Y:Byte; Key:Word; MX1,MX2,MX3:Byte;

  PROCEDURE _Global;
  BEGIN
    Box(X+5,Y+2,X+55,Y+13,$5D,Single1);
    FastWrite(X+6,Y+2,$5B,' Global ');
    WriteHi(X+X2,Y+ 3,$57,$5A,PadLeft(' ~F1~        Help',51,' '));
    WriteHi(X+X2,Y+ 4,$57,$5A,PadLeft(' ~F2~        Save DESCRIPT.ION',51,' '));
    WriteHi(X+X2,Y+ 5,$57,$5A,PadLeft(' ~F6~        Rename file',51,' '));
    WriteHi(X+X2,Y+ 6,$57,$5A,PadLeft(' ~F8 DEL~    Delete file',51,' '));
    WriteHi(X+X2,Y+ 7,$57,$5A,PadLeft(' ~F9~        About program',51,' '));
    WriteHi(X+X2,Y+ 8,$57,$5A,PadLeft(' ~F10~       Change drive',51,' '));
    WriteHi(X+X2,Y+ 9,$57,$5A,PadLeft(' ~TAB '#26'~     Edit file description',51,' '));
    WriteHi(X+X2,Y+10,$57,$5A,PadLeft(' ~ALT+F9~    Switch NORMAL/CONDENSED screen',51,' '));
    WriteHi(X+X2,Y+11,$57,$5A,PadLeft(' ~ALT+X~     Exit to startup dir',51,' '));
    WriteHi(X+X2,Y+12,$57,$5A,PadLeft(' ~ESC~       Exit to current dir',51,' '));
    WriteHi(MX1,Y+16,I,R,'    ~G~lobal     ');
  END;

  PROCEDURE _Editing;
  BEGIN
    Box(X+5,Y+2,X+55,Y+13,$5D,Single1);
    FastWrite(X+6,Y+2,$5B,' Editing ');
    WriteHi(X+X2,Y+ 3,$57,$5A,PadLeft(' ~ALT+A~     Insert char from ASCII table',51,' '));
    WriteHi(X+X2,Y+ 4,$57,$5A,PadLeft(' ~ALT+1~     CURRENT LINE (UPPER)',51,' '));
    WriteHi(X+X2,Y+ 5,$57,$5A,PadLeft(' ~ALT+2~     current line (lower)',51,' '));
    WriteHi(X+X2,Y+ 6,$57,$5A,PadLeft(' ~ALT+3~     Current Line (Proper)',51,' '));
    WriteHi(X+X2,Y+ 7,$57,$5A,PadLeft(' ~ALT+4~     cURRENT lINE (FlIp)',51,' '));
    WriteHi(X+X2,Y+ 8,$57,$5A,PadLeft(' ~CTRL+L~    LEFT justified line',51,' '));
    WriteHi(X+X2,Y+ 9,$57,$5A,PadLeft(' ~CTRL+R~    RIGHT justified line',51,' '));
    WriteHi(X+X2,Y+10,$57,$5A,PadLeft(' ~CTRL+E~    CENTER current line',51,' '));
    WriteHi(X+X2,Y+11,$57,$5A,PadLeft(' ~CTRL+Y~    DELETE CURRENT line',51,' '));
    WriteHi(X+X2,Y+12,$57,$5A,PadLeft(' ~CTRL+Z~    UNDO changes',51,' '));
    WriteHi(MX2,Y+16,I,R,'    ~E~diting    ');
  END;

  PROCEDURE _Copy;
  BEGIN
    Box(X+5,Y+2,X+55,Y+8,$5D,Single1);
    FillScreen(X+5,Y+9,X+55,Y+14,$5D,' ');
    FastWrite(X+6,Y+2,$5B,' Clipboard ');
    WriteHi(X+X2,Y+ 3,$57,$5A,PadLeft(' ~CTRL+X~    Cut description',51,' '));
    WriteHi(X+X2,Y+ 4,$57,$5A,PadLeft(' ~CTRL+C~    Copy description',51,' '));
    WriteHi(X+X2,Y+ 5,$57,$5A,PadLeft(' ~CTRL+V~    Paste description',51,' '));
    WriteHi(X+X2,Y+ 6,$57,$5A,PadLeft(' ~CTRL+D~    Clear description',51,' '));
    WriteHi(X+X2,Y+ 7,$57,$5A,PadLeft(' ~CTRL+Q~    Show clipboard',51,' '));
    WriteHi(MX3,Y+16,I,R,'   ~C~lipboard   ');
  END;


BEGIN
  SaveCursor;
  Cursor(Off);
  X := 10; X2 := 6;
  Y := MaxY DIV 2-8;
  I := $47; R := $4F;
  MX1 := X+6; MX2 := X+22; MX3 := X+39;
  OpenWin(X,Y,60,18,$5D,$5E,Double1,'Help');
  REPEAT
    WriteHi(MX1,Y+16,$57,$5F,'    ~G~lobal     ');
    WriteHi(MX2,Y+16,$57,$5F,'    ~E~diting    ');
    WriteHi(MX3,Y+16,$57,$5F,'   ~C~lipboard   ');
    CASE HelpNum OF
      1: _Global;
      2: _Editing;
      3: _Copy;
    END;
    Key := GetKey;
    CASE Key OF
      Ord('g'),Ord('G'): HelpNum := 1;
      Ord('e'),Ord('E'): HelpNum := 2;
      Ord('c'),Ord('C'): HelpNum := 3;
        kbLeft: IF HelpNum = 1 THEN HelpNum := 3 ELSE Dec(HelpNum);
       kbRight: IF HelpNum = 3 THEN HelpNum := 1 ELSE Inc(HelpNum);
    END;
  UNTIL (Key=kbEnter) OR (Key=kbEsc);
  RmWin;
  RestoreCursor;
END;


PROCEDURE About;
VAR OK: PButtons; Y: Byte;
BEGIN
  SaveCursor;
  Cursor(Off);
  Y := MaxY DIV 2 - 9;
  OpenWin(11,Y,60,20,$5D,$5E,Double1,'About');
  WriteBetween(12,70,Y+1,$5A,'              ');
  WriteBetween(12,70,Y+2,$5A,'Ķ Ŀ   ҿ');
  WriteBetween(12,70,Y+3,$5A,'      Ķ   ');
  WriteBetween(12,70,Y+4,$5A,'    Ľ   ');
  WriteBetween(12,70,Y+5,$5E,Version);
  WriteBetween(12,70,Y+6,$5E,'Copyright (C) 1996-97 by The GodFather');
  WriteBetween(12,70,Y+8,$57,'If you have bug-reports, suggestion or comments');
  WriteBetween(12,70,Y+9,$57,'please write to me. I`ll be happy to answer you');
  WriteBetween(12,70,Y+11,$57,' Contact me here: ');
  WriteBetween(12,70,Y+13,$5B,' Email: gf@top.bg ');
  WriteBetween(12,70,Y+14,$5B,' Email: gf@cybcom.net ');
  WriteBetween(12,70,Y+15,$5B,' URL: http://georgi.top.bg/ ');
  InitPallette(DefaultDialogPAL);
  OK := New(PButtons, Init);
  OK^.AddBtn('    ~O~K    ',kbAltO,36,Y+18,btDefault);
  OK^.Process;
  Dispose(OK,Done);
  RestoreCursor;
  RmWin;
END;


FUNCTION ViewASCII(VAR Current:Byte):Word;
CONST XPos = 22;
VAR Key:Word; UpY,X,Y:Byte;

 PROCEDURE ShowASCII;
 VAR I,R,Cnt:Byte;
 BEGIN
   Cnt := 0;
   FOR I := 0 TO 15 DO
    FOR R := 0 TO 15 DO
    BEGIN
      FastWrite(XPos+2+(R*2),upY+1+I,$5A,Chr(Cnt));
      Inc(Cnt);
    END;
 END;

 FUNCTION RetX(W:Word): Word; ASSEMBLER; ASM MOV AX, W; AND AX, 15; END;
 FUNCTION RetY(W:Word): Word; ASSEMBLER; ASM MOV AX, W; MOV CL, 4; SHR AX, CL; END;

 PROCEDURE Update;
 BEGIN
   Current := Y SHL 4 + X;
   FastWrite(XPos+9 ,UpY+17,$5E,Chr(Current));
   FastWrite(XPos+18,UpY+17,$5E,PadRight(IntToStr(Current),3,'0'));
   FastWrite(XPos+29,UpY+17,$5E,DecToHex(Current)+'h');
 END;

BEGIN
  ViewASCII := $FFFF;
  SaveCursor;
  Cursor(Off);
  UpY := MaxY DIV 2-8;
  OpenWin(XPos,UpY,34,17,$5D,$5E,Single1,'ASCII Table');
  ShowASCII;
  FastWrite(XPos+2 ,upY+17,$57,' Char:   ');
  FastWrite(XPos+12,upY+17,$57,' DEC:     ');
  FastWrite(XPos+23,upY+17,$57,' HEX:     ');

  X := RetX(Current);
  Y := RetY(Current);
  REPEAT
    Update;
    Attribute(XPos+2+Pred(X SHL 1),upY+1+Y,$9B,3);
    Key := ReadKey;
    Attribute(XPos+2+Pred(X SHL 1),upY+1+Y,$5A,3);
    CASE Key OF
      kbUp: IF Y <> 0  THEN Dec(Y);
    kbDown: IF Y <> 15 THEN Inc(Y);
    kbLeft: IF X <> 0  THEN Dec(X);
   kbRight: IF X <> 15 THEN Inc(X);
    kbHome: X := 0;
    kbPgUp: Y := 0;
     kbEnd: X := 15;
    kbPgDn: Y := 15;
    0..255: BEGIN
              X := RetX(Key);
              Y := RetY(Key);
            END;
    END;
  UNTIL (Key = kbEsc) OR (Key = kbEnter);
  IF Key = kbENTER THEN ViewASCII := Ord(Current);
  RmWin;
  RestoreCursor;
END;


PROCEDURE ViewASCII2(VAR Current: Byte);
VAR Key: Word; UpY: Byte;

  PROCEDURE WriteIT(Num: Byte);
  VAR FromChar,ToChar,X,Y: Byte;
  BEGIN
    Y        := UpY+1;
    X        := 15;
    FromChar := Pred(Num)*8;
    ToChar   := FromChar+128;
    REPEAT
      IF X > 60 THEN BEGIN X := 15; Inc(Y); END;
      FastWrite(X,Y,$57,PadRight(IntToStr(FromChar),4,' ')); Inc(X,4);
      FastWrite(X+1,Y,$5A,Chr(FromChar));                    Inc(X,2);
      Inc(FromChar);
    UNTIL FromChar = ToChar;
  END;

BEGIN
  SaveCursor;
  Cursor(Off);
  UpY := MaxY DIV 2-8;
  OpenWin(14,UpY,50,17,$5D,$5E,Single1,'ASCII Table');
  IF (Current = 0) OR (Current > 17) THEN Current := 1;
  WriteIT(Current);
  REPEAT
    WriteVScrollBar(64,UpY+1,UpY+16,$57,Current,17);
    Key := GetKey;
    CASE Key OF
      kbUp  : IF Current > 1  THEN Dec(Current);
      kbDown: IF Current < 17 THEN Inc(Current);
      kbHome,
      kbPgUp: Current := 1;
      kbEnd,
      kbPgDn: Current := 17;
    END;
    WriteIT(Current);
  UNTIL (Key = kbEsc) OR (Key=kbEnter);
  RmWin;
  RestoreCursor;
END;





{===========================================================================}
{=== TFile OBJECT ==========================================================}
{===========================================================================}
FUNCTION  TFile.GetDesc: DescStr;       BEGIN GetDesc := Desc; END;
PROCEDURE TFile.SetDesc(ADesc:DescStr); BEGIN Desc := ADesc; END;

CONSTRUCTOR TFile.Init(AName:FileStr; ASize:LongInt; AAttr:Byte; ADate:LongInt);
BEGIN
  Name := AName;
  Size := ASize;
  Attr := AAttr;
  Date := ADate;
  Desc := '';
  IF (Attr AND Directory) <> 0 THEN Dir := True ELSE Dir := False;
  Inc(TotalSize,Size);
END;

DESTRUCTOR TFile.Done;
BEGIN
  Dec(TotalSize,Size);
END;


FUNCTION FormatFileName(FileName:STRING): STRING;
BEGIN
  IF FileName = '..'
    THEN FormatFileName := PadLeft('..',12,' ')
    ELSE FormatFileName := PadLeft(BaseNameOnly(FileName),8,' ')+' '+
                           PadLeft(ExtOnly(FileName),3,' ');
END;






{===========================================================================}
{=== DESCRIBE FILES ========================================================}
{===========================================================================}
PROCEDURE Describe;
VAR
  DescFile: Text;
  AFile   : PFile;
  FName   : FileStr;
  FDesc   : DescStr;
  Temp    : STRING;
  I,O     : Integer;

BEGIN
  Assign(DescFile,'DESCRIPT.ION');
  {$I-}
      Reset(DescFile);
  {$I+}
  IF IOResult <> 0 THEN Exit;

  WHILE NOT Eof(DescFile) DO
  BEGIN
    Readln(DescFile,Temp);
    IF Temp[1] = ';' THEN Continue;

    Temp  := StripBoth(Temp,' ');

    FName := Copy(Temp,1,Pos(' ',Temp));
    FName := AdjCase(Upper, FName);
    FName := StripBoth(FName,' ');
    IF FName = '' THEN Continue;

    FDesc := StripLeft(Copy(Temp,Pos(' ',Temp),255),' ');

    FOR I := 0 TO 5 DO BEGIN O := Succ(I*40); IF FDesc[O] = #255 THEN FDesc[O] := ' '; END;

    FOR I := 0 TO Files^.Count-1 DO
    BEGIN
      AFile := Files^.At(I);
      IF AFile^.Name = FName THEN
      BEGIN
        AFile^.SetDesc(FDesc);
        Break;
      END;
    END;
  END;
  Close(DescFile);
END;


PROCEDURE SaveDesc;
VAR
  DescFile: Text;
  AFile   : PFile;
  FAttr   : Word;
  A       : DescStr;
  I,R,O,
  Total   : Word;

BEGIN
  Total := 0;
  AFile := Files^.At(0);
  IF AFile^.Name = 'No files' THEN Exit;
  Assign(DescFile,'DESCRIPT.ION');
  SetFAttr(DescFile,0);
  {$I-}
      Rewrite(DescFile);
  {$I+}
  IF IOResult <> 0 THEN Exit;
  {$I-}
  Writeln(DescFile,'; Created with GodFather''s 4EDIT '+Version);
  FOR I := 0 TO Files^.Count-1 DO
  BEGIN
    AFile := Files^.At(I);
    WITH AFile^ DO
    BEGIN
      IF GetDesc <> ''
        THEN BEGIN
               Inc(Total);
               {$IFDEF _4DOS_60}
               Write(DescFile,Name,' ');
               {$ELSE}
               Write(DescFile,PadLeft(Name,12,' ')+' ');
               {$ENDIF}
               A := GetDesc;
               FOR R := 0 TO 5 DO
               BEGIN
                 O := Succ(R*40);
                 IF A[O] = ' ' THEN A[O] := #255;
               END;
               Writeln(DescFile,A);
             END;
    END;
  END;
  Close(DescFile);
  IF Total = 0 THEN Erase(DescFile);
  IF Total <> 0 THEN SetFAttr(DescFile, Hidden OR Archive);
  {$I+}
  Edited := False;
END;


PROCEDURE ReadFiles(Where:STRING);
VAR Dir:SearchRec;
BEGIN
  Where := AddSlash(Where);

  New(Files,Init(1,1));
  FindFirst(Where+'*.*',AnyFile, Dir);
  WHILE DosError = 0 DO
  BEGIN
    IF (Dir.Name <> '.') AND
       ((Dir.Attr AND Directory)<>0)
      THEN Files^.Insert(New(PFile,Init(Dir.Name,Dir.Size,Dir.Attr,Dir.Time)));
    FindNext(Dir);
    IF MemAvail < 32767 THEN Exit;
  END; {Read directories}

  FindFirst(Where+'*.*',AnyFile AND NOT (VolumeID OR Directory OR SysFile), Dir);
  WHILE DosError = 0 DO
  BEGIN
    IF (Dir.Name <> 'DESCRIPT.ION') THEN
      Files^.Insert(New(PFile,Init(Dir.Name,Dir.Size,Dir.Attr,Dir.Time)));
    FindNext(Dir);
    IF MemAvail < 32767 THEN Exit;
  END; {Read files}
  Describe;
  IF Files^.Count = 0 THEN Files^.Insert(New(PFile,Init('No files',0,0,0)));
  Edited := False;
END;

PROCEDURE NewDir(WhatDir:STRING);
VAR AFile:PFile; I:Integer;
BEGIN
  Dispose(Files,Done);
  ReadFiles(WhatDir);
  WITH FilesList^ DO
  BEGIN
    FilesList^.ChangeMaxTopics(MaxY-10, Files^.Count);
    LSTPosition := 1;
    IF OldDir <> '' THEN
      FOR I := 0 TO Files^.Count-1 DO
      BEGIN
        AFile := Files^.At(I);
        IF AFile^.Name = OldDir
          THEN BEGIN
                 LSTPosition := I+1;
                 Break;
               END;
      END;
    ReDraw;
  END;
END;


PROCEDURE ChangeDrive;
LABEL Quit;
VAR ESC:Boolean; Key:Word; Tmp:STRING; UpY:Byte;
BEGIN
  ESC := False;
  UpY := MaxY DIV 2 - 9;
  SaveCursor;
  MkWin(20,UpY+6,42,4,$5D,Special2,'');
  FastWrite(29,UpY+8,$5E,'Enter new drive letter: [ ]');
  FastWrite(54,UpY+8,$5F,CurrDir[1]);
  Cursor(On);
  PosCursor(54,UpY+8);
  Tmp     := '!';
  ClearKBuffer;
  Key     := Ord(UpCase(Chr(GetKey)));
  IF Key = 27 THEN ESC := True;
  IF (Chr(Key) = CurrDir[1]) THEN GOTO Quit;
  IF (Chr(Key) >= 'A') AND (Chr(Key) <= 'Z') THEN Tmp := Chr(Key)+':\';
  IF NOT ESC THEN FastWrite(54,UpY+8,$5F,Tmp[1]);
  {$I-}
    ChDir(Tmp);
  {$I+}
  IF IOResult = 0 THEN
  BEGIN
    RmWin;
    RestoreCursor;
    CurrDir := Tmp;
    NewDir(CurrDir); Exit;
  END;
Quit:
  RmWin;
  RestoreCursor;
END;

PROCEDURE ExitDir;
VAR TMP:STRING; I: Byte; CH: Char;
BEGIN
  TMP := CurrDir;
  IF Length(TMP) > 3 THEN
  BEGIN
    I      := LastPos('\',TMP);
    OldDir := Copy(TMP,I+1,255);
    Delete(TMP,I,255);
    IF Length(TMP) = 2 THEN TMP := TMP+'\';
    {$I-}
      ChDir(TMP);
    {$I+}
    IF IOResult <> 0 THEN ;
    CurrDir := TMP;
    NewDir(CurrDir);
  END;
END;

PROCEDURE EnterDir;
VAR TMP:STRING;
BEGIN
  IF NOT CurrentFile^.Dir THEN Exit;
  IF CurrentFile^.Name = '..' THEN
  BEGIN
    ExitDir;
    Exit;
  END;
  OldDir  := '';
  Tmp     := CurrentFile^.Name;
  CurrDir := AddSlash(CurrDir) + TMP;
  {$I+}
    ChDir(CurrDir);
  {$I-}
  IF IOResult <> 0 THEN ;
  NewDir(CurrDir);
END;




{===========================================================================}
{=== RENAME, DELETE FILES ==================================================}
{===========================================================================}
PROCEDURE RenameFile;
VAR FDlg:PDialog; VAR FName:STRING[12]; OK:Boolean; F:FILE;
BEGIN
  OK := False;
  FName := CurrentFile^.Name;
  IF FName = '..' THEN Exit;
  New(FDlg, Init(16,MaxY DIV 2-4,50,8,DefaultDialogPAL,Single1,'Rename file'));
  WITH FDlg^ DO
  BEGIN
    AddTxtInputLine(12,3,'~F~ile',kbAltF,17,3,12,ilFileName,FName);
    AddButtons;
     AddButton('    ~O~K    ',kbAltO,11,6,btDefault);
     AddButton('  ~C~ancel  ',kbAltC,30,6,btCancel);
    IF (Process(1) = 1) AND (FName<>'') THEN OK := True;
  END;
  Dispose(FDlg, Done);
  IF OK THEN
  BEGIN
    Assign(F,CurrentFile^.Name);
    {$I-}
        Rename(F,FName);
    {$I+}
    IF IOResult <> 0
      THEN InfoBox('Error renaming '+CurrentFile^.Name+' to '+FName,True)
      ELSE BEGIN
             CurrentFile^.Name := FName;
             FilesList^.ReDraw;
             IF CurrentFile^.GetDesc <> ''
                THEN Edited := True;
           END;
  END;
END;

PROCEDURE DelFile;
VAR OK:Byte; F:FILE;
BEGIN
  SaveCursor;
  Cursor(Off);
  IF CurrentFile^.Dir THEN Exit;
  IF CurrentFile^.Name = 'No files' THEN Exit;
  IF NOT PromptBox('Are you sure you want to delete '+CurrentFile^.Name+'?',True) THEN Exit;
  OK := DeleteFile(CurrentFile^.Name);
  IF OK = 0
    THEN BEGIN
           Files^.AtFree(FilesList^.LSTPosition - 1);
           FilesList^.ChangeMaxTopics(MaxY-10, Files^.Count);
         END
    ELSE InfoBox('Error deleting '+CurrentFile^.Name,True);
  RestoreCursor;
END;


PROCEDURE FillDescArray(Desc:DescStr);
BEGIN
  FillChar(FullDesc,SizeOf(FullDesc),0);
  FullDesc[1] := PadLeft(Copy(Desc,  1,40),40,' ');
  FullDesc[2] := PadLeft(Copy(Desc, 41,40),40,' ');
  FullDesc[3] := PadLeft(Copy(Desc, 81,40),40,' ');
  FullDesc[4] := PadLeft(Copy(Desc,121,40),40,' ');
  FullDesc[5] := PadLeft(Copy(Desc,161,40),40,' ');
  FullDesc[6] := PadLeft(Copy(Desc,201,40),40,' ');
END;

PROCEDURE WriteDesc(Desc:DescStr);
BEGIN
  IF Desc = ''
    THEN BEGIN
           ClearText(39,MaxY-6,78,MaxY-1,$17);
           Exit;
         END
    ELSE BEGIN
           FillDescArray(Desc);
           FastWrite(39,MaxY-6,$17,PadLeft(FullDesc[1],40,' '));
           FastWrite(39,MaxY-5,$17,PadLeft(FullDesc[2],40,' '));
           FastWrite(39,MaxY-4,$17,PadLeft(FullDesc[3],40,' '));
           FastWrite(39,MaxY-3,$17,PadLeft(FullDesc[4],40,' '));
           FastWrite(39,MaxY-2,$17,PadLeft(FullDesc[5],40,' '));
           FastWrite(39,MaxY-1,$17,PadLeft(FullDesc[6],40,' '));
         END;
END;




PROCEDURE ShowClipboard(OldDesc:DescStr);
BEGIN
  OpenWin(19,(MaxY DIV 2)-5,43,7,$5D,$5F,Single1,'Clipboard');
  FillDescArray(Clipboard);
  FastWrite(21,(MaxY DIV 2)-4,$17,PadLeft(FullDesc[1],40,' '));
  FastWrite(21,(MaxY DIV 2)-3,$17,PadLeft(FullDesc[2],40,' '));
  FastWrite(21,(MaxY DIV 2)-2,$17,PadLeft(FullDesc[3],40,' '));
  FastWrite(21,(MaxY DIV 2)-1,$17,PadLeft(FullDesc[4],40,' '));
  FastWrite(21,(MaxY DIV 2)-0,$17,PadLeft(FullDesc[5],40,' '));
  FastWrite(21,(MaxY DIV 2)+1,$17,PadLeft(FullDesc[6],40,' '));
  FillDescArray(OldDesc);
  Pause;
  RmWin;
END;



PROCEDURE EditDESCRIPTION;
CONST XMax = 40; YMax = 6;
VAR
  Key       : Word;
  X,Y       : Byte;
  Desc      : DescStr;

  FUNCTION GetLine(Line:Byte):String40;
  BEGIN
    GetLine := FullDesc[Line];
  END;

  PROCEDURE SetLine(Line:Byte; Str:String40);
  BEGIN
    FullDesc[Line] := Str;
  END;

  PROCEDURE Display(X,Y,Attr:Byte);
  VAR I:Byte;
  BEGIN
    FOR I := Y TO Y+5 DO
      FastWrite(X,I,Attr,PadLeft(FullDesc[I-Pred(Y)],40,' '));
  END;

  PROCEDURE Update;
  VAR CStr:String40; A,B:STRING[5]; I:Byte;
  BEGIN
    FOR I := 1 TO YMax DO
    BEGIN
      CStr := GetLine(I);
      CStr := StripRight(CStr,' ');
      SetLine(I, CStr);
    END;

    CStr := GetLine(Y);
    I := Length(CStr);
    IF (I<X) OR (I=0)
      THEN WriteHi(47,MaxY,$13,$19,'~~ <EOL> ~~')
      ELSE BEGIN
             A := '$'+DecToHex(Ord(CStr[X]));
             B := IntToStr(Ord(CStr[X])); IF Length(B) = 2 THEN B := '0'+B;
             WriteHi(47,MaxY,$13,$19,'~~ '+A+','+B+' ~~');
           END;
    PosCursor(39+Pred(X),(MaxY-6)+Pred(Y));
    FastWrite(40,MaxY,$13,' '+PadRight(IntToStr(X),2,'0'));
    FastWrite(43,MaxY,$13,'/'+PadRight(IntToStr(Y),2,'0')+' ');
    IF InsertMode
      THEN WriteHi(58,MaxY,$13,$19,' Insert ~~')
      ELSE FastWrite(58,MaxY,$13,' Overstrike ');
    Display(39,MaxY-6,$57);
  END;

  PROCEDURE SetCursor(_InsertMode:Boolean);
  BEGIN
    InsertMode := _InsertMode;
    IF InsertMode THEN Cursor(Half) ELSE Cursor(On);
  END;

  PROCEDURE GoUp;    BEGIN IF Y <> 1    THEN Dec(Y); END;
  PROCEDURE GoDown;  BEGIN IF Y <> YMax THEN Inc(Y); END;
  PROCEDURE GoLeft;  BEGIN IF X <> 1    THEN Dec(X); END;
  PROCEDURE GoRight; BEGIN IF X <> XMax THEN Inc(X); END;
  PROCEDURE GoHome;  BEGIN X := 1;                   END;
  PROCEDURE GoEnd;   BEGIN X := Succ(Length(GetLine(Y))); IF X > XMax THEN X:=XMax; END;
  PROCEDURE GoPgUp;  BEGIN IF Y  > 2      THEN Dec(Y,2) ELSE Y := 1;    END;
  PROCEDURE GoPgDn;  BEGIN IF Y <  YMax-1 THEN Inc(Y,2) ELSE Y := YMax; END;

  PROCEDURE AddChar;
  VAR CStr: String40;
  BEGIN
    CStr := GetLine(Y);
    IF (Length(CStr) < X) THEN
      REPEAT Insert(' ',CStr,Length(CStr)+1) UNTIL Length(CStr) = X;
    IF InsertMode THEN Insert(Chr(Key),CStr,X) ELSE CStr[X] := Chr(Key);
    SetLine(Y,CStr);
    GoRight;
  END;

  PROCEDURE Del;
  VAR CStr,A,B:String40; CLen:Byte; I:Byte;
  BEGIN
    CStr := GetLine(Y);
    CLen := Length(CStr);
    IF X >= Succ(CLen)
      THEN BEGIN
             IF Y = YMax THEN Exit;
             A := GetLine(Y+1);
             B := Copy(A,1,Succ(XMax-X));
             Delete(A,1,Succ(XMax-X));
             SetLine(Y,PadLeft(CStr,X-1,' ')+B);
             SetLine(Y+1,A);
             IF A = ''
               THEN BEGIN
                      FOR I := Y+1 TO YMax-1 DO SetLine(I,GetLine(I+1));
                      SetLine(YMax,'');
                    END;
           END
      ELSE BEGIN
             Delete(CStr,X,1);
             SetLine(Y,CStr);
           END;
  END;

  PROCEDURE Enter;
  VAR CStr: String40; NewStr: String40; I: Byte;
  BEGIN
    IF Y = YMax THEN Exit;
    FOR I := YMax-1 DOWNTO Y DO SetLine(I+1,GetLine(I));
    CStr   := GetLine(Y);
    NewStr := Copy(CStr,X,XMax);
    SetLine(Y+1,NewStr);
    Delete(CStr,X,XMax);
    SetLine(Y,CStr);
    GoDown; GoHome;
  END;

  PROCEDURE BackSpace;
  VAR CStr:String40;
  BEGIN
    IF X = 1 THEN
      IF Y = 1
        THEN Exit
        ELSE BEGIN
               Dec(Y);
               CStr := GetLine(Y);
               X := Length(CStr)+1;
               IF X <= XMax THEN Inc(X);
             END;
    CStr := GetLine(Y);
    IF X <= Length(CStr)+1 THEN Delete(CStr,X-1,1);
    SetLine(Y,CStr);
    GoLeft;
  END;

  PROCEDURE DelLine;
  VAR I:Byte;
  BEGIN
    IF Y = YMax THEN
    BEGIN
      SetLine(Y,'');
      Exit;
    END;
    FOR I := Y TO YMax-1 DO SetLine(I,GetLine(I+1));
    SetLine(YMax,'');
  END;

  FUNCTION GetWholeDescription:DescStr;
  VAR Temp:DescStr; X:Byte;
  BEGIN
    FillChar(Temp,SizeOf(Temp),0);
    FOR X := 1 TO 6 DO Temp := Concat(Temp,PadLeft(FullDesc[X],40,' '));
    Temp := StripRight(Temp,' ');
    GetWholeDescription := Temp;
  END;

BEGIN
  SaveCursor;
  Desc := CurrentFile^.GetDesc;
  Desc := StripRight(Desc,' ');

  FillDescArray(Desc);

  SetCursor(InsertMode);
  X:=1; Y:=1;
  REPEAT
    Update;
    Key := GetKey;
    CASE Key OF
      kbF1         : Help(2);

      kbCtrlX      : BEGIN
                       Clipboard := GetWholeDescription;
                       FillDescArray('');
                     END;
      kbCtrlC      : Clipboard := GetWholeDescription;
      kbCtrlV      : FillDescArray(Clipboard);
      kbCtrlD      : FillDescArray('');
      kbCtrlQ      : ShowClipboard(GetWholeDescription);

      kbAltA       : BEGIN
                       Key := ViewASCII(Upper_ASCII);
                       IF Key <> $FFFF THEN AddChar;
                     END;
      kbAltB       : ViewASCII2(Upper_ASCII2);
      kbUp         : GoUp;
      kbDown       : GoDown;
      kbLeft       : GoLeft;
      kbRight      : GoRight;
      kbHome       : GoHome;
      kbEnd        : GoEnd;
      kbPgUp       : GoPgUp;
      kbPgDn       : GoPgDn;

      kbIns        : SetCursor(NOT InsertMode);
      kbSpace..255 : AddChar;

      kbDel        : Del;
      kbEnter      : Enter;
      kbBSpace     : BackSpace;
      kbAltD,
      kbCtrlY      : DelLine;

      kbCtrlL      : SetLine(Y,StripLeft(GetLine(Y),' '));
      kbCtrlR      : SetLine(Y,PadRight(GetLine(Y),XMax,' '));
      kbCtrlE      : SetLine(Y,PadCenter( StripLeft(GetLine(Y),' '), XMax,' '));
      kbCtrlZ      : FillDescArray(Desc);
      kbCtrlBSpace : BEGIN
                       X := 1; Y := 1;
                       FillDescArray('');
                     END;
      kbAlt1       : FullDesc[Y] := AdjCase(Upper     ,FullDesc[Y]);
      kbAlt2       : FullDesc[Y] := AdjCase(Lower     ,FullDesc[Y]);
      kbAlt3       : FullDesc[Y] := AdjCase(ProperNorm,FullDesc[Y]);
      kbAlt4       : FullDesc[Y] := AdjCase(Flip      ,FullDesc[Y]);
    END;
    Update;
  UNTIL Key = kbEsc;
  CurrentFile^.SetDesc(GetWholeDescription);
  FilesList^.ReDraw;
  IF Desc <> GetWholeDescription THEN Edited := True;
  RestoreCursor;
END;




PROCEDURE SwitchLines;
BEGIN
  IF NOT EgaVgaSystem THEN Exit;
  NormalLines := NOT NormalLines;
  ClearAttr(1,1,1,20,0);
  IF NormalLines THEN SetNormalLines ELSE SetCondensedLines;
  Cursor(Off);
  PosCursor(80,MaxY);
  DrawMainScreen;
  FilesList^.FastFindY  := MaxY-7;
  FilesList^.ScrollerY2 := MaxY-8;
  FilesList^.ChangeMaxTopics(MaxY-10, Files^.Count);
END;



PROCEDURE TFilesList.__IdleListCall(ListPos: Integer);
VAR Dt   : DateTime;
    AFile: PFile;
    SName: STRING[20];
    SSize: STRING[20];
    SDate: STRING[20];
    TFile: STRING[20];
    TSize: STRING[20];

FUNCTION AZ(A:LongInt): STRING; VAR S:STRING[5]; BEGIN S:=IntToStr(A); IF Length(S) = 1 THEN S:='0'+S; AZ:=S; END;

BEGIN
  FastWrite(5,MaxY,$19,' '+PadLeft(CurrDir+' ',70,#205));
  AFile := Files^.At(ListPos-1);
  TFile := PadLeft(AddComas(Files^.Count),20,' ');
  TSize := PadLeft(AddComas(TotalSize),20,' ');
  WITH AFile^ DO
  BEGIN
    SName := PadLeft(Name,25,' ');
    IF Size = 0
      THEN SSize := '-'+Replicate(19,' ')
      ELSE SSize := PadLeft(AddComas(Size),25,' ');
    IF Name <> 'No files' THEN
    BEGIN
      IF (Attr AND Archive)   <> 0 THEN FastWrite(16,MaxY-3,$1E,'ARC') ELSE FastWrite(16,MaxY-3,$18,'arc');
      IF (Attr AND ReadOnly)  <> 0 THEN FastWrite(20,MaxY-3,$1E,'R/O') ELSE FastWrite(20,MaxY-3,$18,'r/o');
      IF (Attr AND Hidden)    <> 0 THEN FastWrite(24,MaxY-3,$1E,'HID') ELSE FastWrite(24,MaxY-3,$18,'hid');
      IF (Attr AND SysFile)   <> 0 THEN FastWrite(28,MaxY-3,$1E,'SYS') ELSE FastWrite(28,MaxY-3,$18,'sys');
      IF (Attr AND Directory) <> 0 THEN FastWrite(32,MaxY-3,$1E,'DIR') ELSE FastWrite(32,MaxY-3,$18,'dir');
    END ELSE FastWrite(16,MaxY-4,$1E,'-'+Replicate(19,' '));
    UnpackTime(Date, DT);
    WITH DT DO SDate := AZ(Day) +'-'+AZ(Month)+'-'+AZ(Year)+
                    ' '+AZ(Hour)+':'+AZ(Min);
    IF Name = 'No files'
      THEN BEGIN
             SName := '-'+Replicate(19,' ');
             SSize := '-'+Replicate(19,' ');
             SDate := '-'+Replicate(19,' ');
             TFile := '-'+Replicate(19,' ');
             TSize := '-'+Replicate(19,' ');
           END;
  END;
  FastWrite(16,MaxY-6,$1E,SName);
  FastWrite(16,MaxY-5,$1E,SSize);
  FastWrite(16,MaxY-4,$1E,SDate);
  FastWrite(16,MaxY-2,$1E,TFile);
  FastWrite(16,MaxY-1,$1E,TSize);
  WriteDesc(AFile^.GetDesc);
  IF Edited
    THEN FastWrite(78,MaxY,$1B,#15)
    ELSE FastWrite(78,MaxY,$19,#205);
END;

FUNCTION TFilesList.__GetLine(ListPos: Integer): STRING;
VAR AFile:PFile; Dt:DateTime; S:STRING; DirStr:STRING[12];
BEGIN
  AFile := Files^.At(ListPos-1);
  WITH AFile^ DO
  BEGIN
    DirStr := '<SUB-DIR>';
    IF Name = '..' THEN Overwrite(2,DirStr,'UP-');
    IF Dir
      THEN S := FormatFileName(Name)+PadLeft('   '+DirStr,12,' ')
      ELSE S := FormatFileName(Name)+PadRight(AddComas(Size),12,' ');
    S := S+' ---------> ';
    S := PadLeft(S,36,' ')+PadLeft(GetDesc,41,' ');
    IF Length(GetDesc) > 40 THEN S[77] := #16;
  END;
  IF AFile^.Name = 'No files' THEN S := PadCenter('No files in this directory',77,' ');
  __GetLine := ' '+S;
END;


PROCEDURE TFilesList.__HookListKeys(ListPos:Integer; VAR PressedKey:Word);

  FUNCTION AskToSaveDesc:Boolean;
  VAR Tmp:Byte;
  BEGIN
    AskToSaveDesc := True;
    IF Edited THEN
    BEGIN
      Tmp := AltPromptBox('Save DESCRIPT.ION?',True);
      CASE Tmp OF
        1: SaveDesc;
        3: AskToSaveDesc := False;
      END;
    END;
  END;

BEGIN
  CurrentFile := Files^.At(ListPos-1);
  CASE PressedKey OF
      kbEnter: IF CurrentFile^.Dir THEN IF AskToSaveDesc THEN EnterDir;
     kbBSpace: IF AskToSaveDesc THEN ExitDir;

kbTab,kbRight: IF CurrentFile^.Name <> 'No files' THEN EditDescription;

      kbCtrlX: BEGIN
                 Clipboard := CurrentFile^.GetDesc;
                 CurrentFile^.SetDesc('');
                 Edited := True;
                 ReDraw;
               END;
      kbCtrlC: BEGIN
                 Clipboard := CurrentFile^.GetDesc;
                 ReDraw;
               END;
      kbCtrlV: BEGIN
                 CurrentFile^.SetDesc(Clipboard);
                 Edited := True;
                 ReDraw;
               END;
      kbCtrlD: BEGIN
                 IF CurrentFile^.GetDesc <> '' THEN Edited := True;
                 CurrentFile^.SetDesc('');
                 ReDraw;
               END;
      kbCtrlQ: ShowClipboard('');

      kbAltF9: SwitchLines;
         kbF1: Help(1);
         kbF2: SaveDesc;
         kbF6: RenameFile;
   kbDel,kbF8: DelFile;
         kbF9: About;
        kbF10: IF AskToSaveDesc THEN ChangeDrive;
       kbAltX: IF AskToSaveDesc THEN BEGIN
                                       {$I-}
                                           ChDir(OrigDir);
                                       {$I+}
                                       EndOfList := True;
                                     END;
        kbEsc: IF NOT AskToSaveDesc THEN PressedKEY := 0;
  END;
END;


PROCEDURE Process;
BEGIN
  New(FilesList);
  WITH FilesList^ DO
  BEGIN
    Init(2,3,78,MaxY-10,Files^.Count,False,True,3,MaxY-7,#196,True,80,3,MaxY-8,lDefaultPal);
    Pallette[lScroller] := $17;
    Process;
  END;
  Dispose(FilesList, Done);
END;


PROCEDURE Initialize;
BEGIN
  GetDir(0,OrigDir);
  CurrDir := FExpand(OrigDir);
  ReadFiles(CurrDir);
  Upper_ASCII := 120;
  Upper_ASCII2:= 1;
  InsertMode  := True;
  NormalLines := True;
  FillChar(Clipboard,SizeOf(Clipboard),0);
  Cursor(Off);
  DrawMainScreen;
END;


PROCEDURE Quit;
BEGIN
  ClrScr(7);
  IF NOT NormalLines THEN SetNormalLines;
  Cursor(Off);
  SetPal(OrgPal);
  SetBlink(True);
  PartRestore(1,(MaxY DIV 2)-11,80,(MaxY DIV 2)+13, @_4E_Logo^);
  PosCursor(1,MaxY-2);
  Cursor(On);
END;


BEGIN
  Initialize;
  Process;
  Quit;
END.